//+----------------------------------------------------------------------------------+
//|                                                                                      Bulls.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                                        xxxx://www.metaquotes.net |
//+----------------------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 1 //<------- I want to add a Moving Average so I guess this needs increasing to 2?
#property indicator_minimum -1.0 // <-------I have added this to show minimum value in range
#property indicator_maximum 1.0 // <-------I have added this to show maximum value in range
#property indicator_color1 Lime
#property indicator_level1 0.0004 // <-------I have added this to show in the levels tab and also on the Indicator separate chart
//---- input parameters
extern int BullsPeriod=13;
//---- buffers
double BullsBuffer[];
double MABuffer[]; //<- I have added this buffer for handling the MA line
double TempBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                  |
//+------------------------------------------------------------------+
int init()
  {
  string short_name;
//---- (original comment) 1 additional buffer used for counting.
  IndicatorBuffers(2);                                  // <-- does this need increasing to 3?
  IndicatorDigits(Digits);
//---- indicator line
  SetIndexStyle(0,DRAW_HISTOGRAM);
  SetIndexBuffer(0,BullsBuffer);
 // SetIndexBuffer(1,TempBuffer);
  SetIndexBuffer(1,MABuffer);                          //<-- I added this but not proceed past this point
  SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 2, Yellow);  //<-- I added this but not proceed past this point
 // SetIndexLabel(2, "MA " + MAperiod);                  //<-- I added this but not proceed past this point
//---- name for DataWindow and indicator subwindow label
  short_name="Bulls("+BullsPeriod+")";
  IndicatorShortName(short_name);
  SetIndexLabel(0,short_name);
//----
  return(0);
  }
//+------------------------------------------------------------------+
//| Bulls Power                                                      |
//+------------------------------------------------------------------+
int start()
  {
  int i,counted_bars=IndicatorCounted();
//----
  if(Bars<=BullsPeriod) return(0);
//----
  int limit=Bars-counted_bars;
  if(counted_bars>0) limit++;
  for(i=0; i<limit; i++)
      { MABuffer[i] /*TempBuffer[i]*/=iMA(NULL,0,BullsPeriod,0,MODE_EMA,PRICE_CLOSE,i);
        BullsBuffer[i]=High[i]-MABuffer[i]; /*TempBuffer[i]*/
        }//----
/*
  i=Bars-counted_bars-1;
  while(i>=0)
    {
     
      i--;
    }
*/
//----
  return(0);
  }
//+------------------------------------------------------------------+